<?php

// (C) 2015 Dennis Leeuw (dleeuw@made-it.com)
// License: GPLv3 (see: http://www.gnu.org/licenses/gpl-3.0.html)

// Variables
$cmd_ban_ip = "/opt/ban-ip/ban-ip";

// Functions
function banip_ban_ip($my_cmd,$ip) {
	exec("sudo $my_cmd ban $ip",$out,$err);
	if ($err != 0) {
		echo "Failed to ban " . $ip . " on " . $_SERVER['SERVER_ADDR'] . "\n";
		exit($err);
	}
}

function banip_unban_ip($my_cmd,$ip) {
	exec("sudo $my_cmd unban $ip",$out,$err);
	if ($err == "0") {
		echo "Failed to unban " . $ip . " on " . $_SERVER['SERVER_ADDR'] . "\n";
		exit($err);
	}
}

function banip_list($my_cmd) {
	exec("sudo $my_cmd show",$out,$err);
	if ($err != 0) {
		echo "Failed to list " . $table . " on " . $_SERVER['SERVER_ADDR'] . "\n";
		exit($err);
	} else {
		foreach ($out as $ip) {
			echo $ip . "\n";
		}
	}
}

function parse_argv($arg) {
	$args = $arg + 1;
	if (count($_SERVER["argv"]) >= $args) {
		return ($_SERVER["argv"][$arg]);
	} else {
		return;
	}
}

function parse_get($elm) {
	return htmlspecialchars($_GET["$elm"]);
}

function parse_post($elm) {
	return htmlspecialchars($_POST["$elm"]);
}

// Main

// How are we called
if (count($_GET) != 0) {
	$command=parse_get('command');
	$black_ip=parse_get('ip');
} elseif (count($_POST) != 0) {
	$command=parse_post('command');
	$black_ip=parse_post('ip');
} elseif ($_SERVER["argv"] != "") {
	$command=parse_argv(1);
	$black_ip=parse_argv(2);
} else {
	exit(1);
}

// Do action
if ($command == "ban") {
	banip_ban_ip($cmd_ban_ip,$black_ip);
} elseif ($command == "unban") {
	banip_unban_ip($cmd_ban_ip,$black_ip);
} elseif ($command == "list") {
	banip_list($cmd_ban_ip);
}

// End
exit(0);
?>
